//---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "common.h"
//---------------------------------------------------------------------------
#pragma pack(push,1)
typedef struct {
  BYTE bFF[16];
  BYTE b00[16];
  BYTE b55[16];
  BYTE num;
  BYTE type;
  WORD start;
  WORD length;
  BYTE name[8];
  BYTE crc;
} PMD_TAPE_HEADER;
#pragma pack(pop)

//---------------------------------------------------------------------------
void calculateChecksum(BYTE *buf, int len, BYTE *pcrc)
{
  int ii;
  BYTE crc = *pcrc;
  BYTE *p = buf;

  for (ii = 0 ; ii < len; ii++)
    crc += *p++;
  *pcrc = crc;
}
//---------------------------------------------------------------------------
void constructHeaderBlock(BYTE **out, BYTE *blkData, int blkLen, char blkType,
                          int blkNum, char *name, int beginAddr)
{
  PMD_TAPE_HEADER ptp;
  int i;
  char *p;
  BYTE *o, crc;

  p = name;
  for (i = 0; i < 8; i++) {
    if (*p == 0)
      ptp.name[i] = ' ';
    else
      ptp.name[i] = (BYTE) toupper(*p++);
  }

  memset(&ptp.bFF, 0xFF, sizeof(ptp.bFF));
  memset(&ptp.b00, 0x00, sizeof(ptp.b00));
  memset(&ptp.b55, 0x55, sizeof(ptp.b55));
  ptp.num = (BYTE) blkNum;
  ptp.type = blkType;
  ptp.start = (WORD) beginAddr;
  ptp.length = (WORD) (blkLen - 1);
  ptp.crc = 0;
  calculateChecksum(&ptp.num, sizeof(PMD_TAPE_HEADER) - 49, &ptp.crc);

  o = *out;
  *(WORD *) o = (WORD) sizeof(PMD_TAPE_HEADER);
  o += 2;
  memcpy(o, &ptp, sizeof(PMD_TAPE_HEADER));
  o += sizeof(PMD_TAPE_HEADER);

  *(WORD *) o = (WORD) (blkLen + 1);
  o += 2;
  memcpy(o, blkData, blkLen);
  crc = 0;
  calculateChecksum(o, blkLen, &crc);
  o += blkLen;
  *o++ = crc;

  *out = o;
}
//---------------------------------------------------------------------------
void constructHeaderlessBlock(BYTE **out, BYTE *blkData, int blkLen)
{
  BYTE *o = *out;

  *(WORD *) o = (WORD) blkLen;
  o += 2;
  memcpy(o, blkData, blkLen);
  o += blkLen;

  *out = o;
}
//---------------------------------------------------------------------------

